Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs	(revision 15273)
@@ -11,24 +11,24 @@
   [StorableClass]
   public class PushConfigurationParameterCollection : PushConfigurationBase, IReadOnlyPushConfiguration {
-    private const string InstructionsParameterName = "Instructions";
-    private const string InstructionsParameterDescription = "Enables/Disables Instructions";
-    private const string EvalPushLimitParameterName = "EvalPushLimit";
-    private const string EvalPushLimitParameterDescription = "This is the maximum allowed number of \"executions\" in a single top-level call to the interpreter. The execution of a single Push instruction counts as one execution, as does the processing of a single literal, as does the descent into one layer of parentheses (that is, the processing of the \"(\" counts as one execution).";
-    private const string MaxPointsInProgramParameterName = "MaxProgramLength";
-    private const string MaxProgramLengthParameterDescription = "This is the maximum size of an item on the CODE/EXEC stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
-    private const string TopLevelPushCodeParameterName = "TopLevelPushCode";
-    private const string TopLevelPushCodeParameterDescription = "When TRUE (which is the default), code passed to the top level of the interpreter will be pushed onto the CODE stack prior to execution.";
-    private const string TopLevelPopCodeParameterName = "TopLevelPopCode";
-    private const string TopLevelPopCodeParameterDescription = "When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.";
-    private const string MaxPointsInRandomInstructionParameterName = "MaxPointsInRandomInstruction";
-    private const string MaxPointsInRandomInstructionParameterDescription = "MaxPointsInRandomInstruction";
-    private const string ErcOptionsParameterName = "ERC options";
-    private const string MaxStringLengthParameterName = "Max. string length";
-    private const string MaxDepthParameterName = "Max. program recursion";
-    private const string MaxParenthesesCloseParameterName = "Max. parentheses close";
-    private const string MaxParenthesesCloseParameterDescription = "Specifies how many sub programs are closed if open during the recursive translation of an individual to a push program. Value is exclusive.";
-    private const string ParenthesesCloseBiasLevelParameterName = "Parentheses close bias level";
-    private const string ParenthesesCloseBiasLevelParameterDescription = "Specifies how strong a random value between 0 .. 'Max. parentheses close' is biased towards 0. In other words, this parameter controls the length of sub programs.";
-    private const string MaxVectorLengthParameterName = "Max. vector length";
+    private const string INSTRUCTIONS_PARAMETER_NAME = "Instructions";
+    private const string INSTRUCTIONS_PARAMETER_DESCRIPTION = "Enables/Disables Instructions";
+    private const string EVAL_PUSH_LIMIT_PARAMETER_NAME = "EvalPushLimit";
+    private const string EVAL_PUSH_LIMIT_PARAMETER_DESCRIPTION = "This is the maximum allowed number of \"executions\" in a single top-level call to the interpreter. The execution of a single Push instruction counts as one execution, as does the processing of a single literal, as does the descent into one layer of parentheses (that is, the processing of the \"(\" counts as one execution).";
+    private const string MAX_POINTS_IN_PROGRAM_PARAMETER_NAME = "MaxProgramLength";
+    private const string MAX_PROGRAM_LENGTH_PARAMETER_DESCRIPTION = "This is the maximum size of an item on the CODE/EXEC stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
+    private const string TOP_LEVEL_PUSH_CODE_PARAMETER_NAME = "TopLevelPushCode";
+    private const string TOP_LEVEL_PUSH_CODE_PARAMETER_DESCRIPTION = "When TRUE (which is the default), code passed to the top level of the interpreter will be pushed onto the CODE stack prior to execution.";
+    private const string TOP_LEVEL_POP_CODE_PARAMETER_NAME = "TopLevelPopCode";
+    private const string TOP_LEVEL_POP_CODE_PARAMETER_DESCRIPTION = "When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.";
+    private const string MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_NAME = "MaxPointsInRandomInstruction";
+    private const string MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_DESCRIPTION = "MaxPointsInRandomInstruction";
+    private const string ERC_OPTIONS_PARAMETER_NAME = "ERC options";
+    private const string MAX_STRING_LENGTH_PARAMETER_NAME = "Max. string length";
+    private const string MAX_DEPTH_PARAMETER_NAME = "Max. program recursion";
+    private const string MAX_PARENTHESES_CLOSE_PARAMETER_NAME = "Max. parentheses close";
+    private const string MAX_PARENTHESES_CLOSE_PARAMETER_DESCRIPTION = "Specifies how many sub programs are closed if open during the recursive translation of an individual to a push program. Value is exclusive.";
+    private const string PARENTHESES_CLOSE_BIAS_LEVEL_PARAMETER_NAME = "Parentheses close bias level";
+    private const string PARENTHESES_CLOSE_BIAS_LEVEL_PARAMETER_DESCRIPTION = "Specifies how strong a random value between 0 .. 'Max. parentheses close' is biased towards 0. In other words, this parameter controls the length of sub programs.";
+    private const string MAX_VECTOR_LENGTH_PARAMETER_NAME = "Max. vector length";
 
     public PushConfigurationParameterCollection() {
@@ -62,77 +62,77 @@
 
     private void InitParameters() {
-      if (!Parameters.ContainsKey(InstructionsParameterName))
-        Parameters.Add(new ValueParameter<IEnabledExpressionsConfiguration>(
-          InstructionsParameterName,
-          InstructionsParameterDescription,
+      if (!Parameters.ContainsKey(INSTRUCTIONS_PARAMETER_NAME))
+        Parameters.Add(new ValueParameter<IExpressionsConfiguration>(
+          INSTRUCTIONS_PARAMETER_NAME,
+          INSTRUCTIONS_PARAMETER_DESCRIPTION,
           this));
 
-      if (!Parameters.ContainsKey(ErcOptionsParameterName))
-        Parameters.Add(new ValueParameter<ErcOptions>(ErcOptionsParameterName));
-
-      if (!Parameters.ContainsKey(MaxVectorLengthParameterName))
-        Parameters.Add(new FixedValueParameter<IntValue>(
-          MaxVectorLengthParameterName,
+      if (!Parameters.ContainsKey(ERC_OPTIONS_PARAMETER_NAME))
+        Parameters.Add(new ValueParameter<ErcOptions>(ERC_OPTIONS_PARAMETER_NAME));
+
+      if (!Parameters.ContainsKey(MAX_VECTOR_LENGTH_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_VECTOR_LENGTH_PARAMETER_NAME,
           new IntValue(500)) { Hidden = true });
 
-      if (!Parameters.ContainsKey(EvalPushLimitParameterName))
-        Parameters.Add(new FixedValueParameter<IntValue>(
-          EvalPushLimitParameterName,
-          EvalPushLimitParameterDescription,
+      if (!Parameters.ContainsKey(EVAL_PUSH_LIMIT_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          EVAL_PUSH_LIMIT_PARAMETER_NAME,
+          EVAL_PUSH_LIMIT_PARAMETER_DESCRIPTION,
           new IntValue(1000)));
 
-      if (!Parameters.ContainsKey(MaxPointsInProgramParameterName))
-        Parameters.Add(new FixedValueParameter<IntValue>(
-          MaxPointsInProgramParameterName,
-          MaxProgramLengthParameterDescription,
+      if (!Parameters.ContainsKey(MAX_POINTS_IN_PROGRAM_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_POINTS_IN_PROGRAM_PARAMETER_NAME,
+          MAX_PROGRAM_LENGTH_PARAMETER_DESCRIPTION,
           new IntValue(200)));
 
-      if (!Parameters.ContainsKey(MaxParenthesesCloseParameterName))
-        Parameters.Add(new FixedValueParameter<IntValue>(
-          MaxParenthesesCloseParameterName,
-          MaxParenthesesCloseParameterDescription,
+      if (!Parameters.ContainsKey(MAX_PARENTHESES_CLOSE_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_PARENTHESES_CLOSE_PARAMETER_NAME,
+          MAX_PARENTHESES_CLOSE_PARAMETER_DESCRIPTION,
           new IntValue(4)) { Hidden = true });
 
-      if (!Parameters.ContainsKey(ParenthesesCloseBiasLevelParameterName))
+      if (!Parameters.ContainsKey(PARENTHESES_CLOSE_BIAS_LEVEL_PARAMETER_NAME))
         Parameters.Add(new FixedValueParameter<DoubleValue>(
-          ParenthesesCloseBiasLevelParameterName,
-          ParenthesesCloseBiasLevelParameterDescription,
+          PARENTHESES_CLOSE_BIAS_LEVEL_PARAMETER_NAME,
+          PARENTHESES_CLOSE_BIAS_LEVEL_PARAMETER_DESCRIPTION,
           new DoubleValue(4)) { Hidden = true });
 
-      if (!Parameters.ContainsKey(TopLevelPushCodeParameterName))
+      if (!Parameters.ContainsKey(TOP_LEVEL_PUSH_CODE_PARAMETER_NAME))
         Parameters.Add(new FixedValueParameter<BoolValue>(
-          TopLevelPushCodeParameterName,
-          TopLevelPushCodeParameterDescription,
+          TOP_LEVEL_PUSH_CODE_PARAMETER_NAME,
+          TOP_LEVEL_PUSH_CODE_PARAMETER_DESCRIPTION,
           new BoolValue(true)) { Hidden = true });
 
-      if (!Parameters.ContainsKey(TopLevelPopCodeParameterName))
+      if (!Parameters.ContainsKey(TOP_LEVEL_POP_CODE_PARAMETER_NAME))
         Parameters.Add(new FixedValueParameter<BoolValue>(
-          TopLevelPopCodeParameterName,
-          TopLevelPopCodeParameterDescription,
+          TOP_LEVEL_POP_CODE_PARAMETER_NAME,
+          TOP_LEVEL_POP_CODE_PARAMETER_DESCRIPTION,
           new BoolValue(false)) { Hidden = true });
 
-      if (!Parameters.ContainsKey(MaxPointsInRandomInstructionParameterName))
-        Parameters.Add(new FixedValueParameter<IntValue>(
-          MaxPointsInRandomInstructionParameterName,
-          MaxPointsInRandomInstructionParameterDescription,
+      if (!Parameters.ContainsKey(MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_NAME,
+          MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_DESCRIPTION,
           new IntValue(50)) { Hidden = true });
 
-      if (!Parameters.ContainsKey(MaxStringLengthParameterName))
-        Parameters.Add(new FixedValueParameter<IntValue>(
-          MaxStringLengthParameterName,
+      if (!Parameters.ContainsKey(MAX_STRING_LENGTH_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_STRING_LENGTH_PARAMETER_NAME,
           new IntValue(1000)) { Hidden = true });
 
-      if (!Parameters.ContainsKey(MaxDepthParameterName))
-        Parameters.Add(new FixedValueParameter<IntValue>(
-          MaxDepthParameterName,
+      if (!Parameters.ContainsKey(MAX_DEPTH_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_DEPTH_PARAMETER_NAME,
           new IntValue(1000)) { Hidden = true });
     }
 
-    public IValueParameter<IEnabledExpressionsConfiguration> InstructionsParameter
-    {
-      get { return (IValueParameter<IEnabledExpressionsConfiguration>)Parameters[InstructionsParameterName]; }
-    }
-
-    public IEnabledExpressionsConfiguration Instructions
+    public IValueParameter<IExpressionsConfiguration> InstructionsParameter
+    {
+      get { return (IValueParameter<IExpressionsConfiguration>)Parameters[INSTRUCTIONS_PARAMETER_NAME]; }
+    }
+
+    public IExpressionsConfiguration Instructions
     {
       get { return InstructionsParameter.Value; }
@@ -142,5 +142,5 @@
     public IValueParameter<ErcOptions> ErcOptionsParameter
     {
-      get { return (IValueParameter<ErcOptions>)Parameters[ErcOptionsParameterName]; }
+      get { return (IValueParameter<ErcOptions>)Parameters[ERC_OPTIONS_PARAMETER_NAME]; }
     }
 
@@ -181,5 +181,5 @@
     public IValueParameter<IntValue> EvalPushLimitParameter
     {
-      get { return (IValueParameter<IntValue>)Parameters[EvalPushLimitParameterName]; }
+      get { return (IValueParameter<IntValue>)Parameters[EVAL_PUSH_LIMIT_PARAMETER_NAME]; }
     }
 
@@ -198,5 +198,5 @@
     public IValueParameter<DoubleValue> ParenthesesCloseBiasLevelParameter
     {
-      get { return (IValueParameter<DoubleValue>)Parameters[ParenthesesCloseBiasLevelParameterName]; }
+      get { return (IValueParameter<DoubleValue>)Parameters[PARENTHESES_CLOSE_BIAS_LEVEL_PARAMETER_NAME]; }
     }
 
@@ -212,5 +212,5 @@
     public IValueParameter<IntValue> MaxParenthesesCloseParameter
     {
-      get { return (IValueParameter<IntValue>)Parameters[MaxParenthesesCloseParameterName]; }
+      get { return (IValueParameter<IntValue>)Parameters[MAX_PARENTHESES_CLOSE_PARAMETER_NAME]; }
     }
 
@@ -229,5 +229,5 @@
     public IValueParameter<IntValue> MaxDepthParameter
     {
-      get { return (IValueParameter<IntValue>)Parameters[MaxDepthParameterName]; }
+      get { return (IValueParameter<IntValue>)Parameters[MAX_DEPTH_PARAMETER_NAME]; }
     }
 
@@ -249,5 +249,5 @@
     public IValueParameter<IntValue> MaxPointsInProgramParameter
     {
-      get { return (IValueParameter<IntValue>)Parameters[MaxPointsInProgramParameterName]; }
+      get { return (IValueParameter<IntValue>)Parameters[MAX_POINTS_IN_PROGRAM_PARAMETER_NAME]; }
     }
 
@@ -263,5 +263,5 @@
     public IValueParameter<IntValue> MaxVectorLengthParameter
     {
-      get { return (IValueParameter<IntValue>)Parameters[MaxVectorLengthParameterName]; }
+      get { return (IValueParameter<IntValue>)Parameters[MAX_VECTOR_LENGTH_PARAMETER_NAME]; }
     }
 
@@ -277,5 +277,5 @@
     public IValueParameter<IntValue> MaxPointsInRandomExpressionParameter
     {
-      get { return (IValueParameter<IntValue>)Parameters[MaxPointsInRandomInstructionParameterName]; }
+      get { return (IValueParameter<IntValue>)Parameters[MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_NAME]; }
     }
 
@@ -295,5 +295,5 @@
     public IValueParameter<BoolValue> TopLevelPushCodeParameter
     {
-      get { return (IValueParameter<BoolValue>)Parameters[TopLevelPushCodeParameterName]; }
+      get { return (IValueParameter<BoolValue>)Parameters[TOP_LEVEL_PUSH_CODE_PARAMETER_NAME]; }
     }
 
@@ -312,5 +312,5 @@
     public IValueParameter<BoolValue> TopLevelPopCodeParameter
     {
-      get { return (IValueParameter<BoolValue>)Parameters[TopLevelPopCodeParameterName]; }
+      get { return (IValueParameter<BoolValue>)Parameters[TOP_LEVEL_POP_CODE_PARAMETER_NAME]; }
     }
 
@@ -326,5 +326,5 @@
     public IValueParameter<IntValue> MaxStringLengthParameter
     {
-      get { return (IValueParameter<IntValue>)Parameters[MaxStringLengthParameterName]; }
+      get { return (IValueParameter<IntValue>)Parameters[MAX_STRING_LENGTH_PARAMETER_NAME]; }
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/IPlushOperator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/IPlushOperator.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/IPlushOperator.cs	(revision 15273)
@@ -0,0 +1,7 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Encoding {
+  using HeuristicLab.Core;
+
+  public interface IPlushOperator : IOperator {
+
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEncoding.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEncoding.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEncoding.cs	(revision 15273)
@@ -0,0 +1,47 @@
+﻿using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Encoding {
+
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Optimization;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator;
+
+  [Item("PlushEncoding", "Describes an linear push (Plush) encoding.")]
+  [StorableClass]
+  public class PlushEncoding : Encoding<IPlushCreator> {
+    public PlushEncoding(bool deserializing)
+      : base(deserializing) {
+    }
+
+    public PlushEncoding(Encoding<IPlushCreator> original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public PlushEncoding(string name)
+      : base(name) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PlushEncoding(this, cloner);
+    }
+
+    public override void ConfigureOperators(IEnumerable<IOperator> operators) {
+      //ConfigureBoundedOperators(operators.OfType<IBoundedIntegerVectorOperator>());
+      //ConfigureCreators(operators.OfType<IPlushCreator>());
+      //ConfigureCrossovers(operators.OfType<IIntegerVectorCrossover>());
+      //ConfigureManipulators(operators.OfType<IIntegerVectorManipulator>());
+      //ConfigureShakingOperators(operators.OfType<IIntegerVectorMultiNeighborhoodShakingOperator>());
+      //ConfigureStrategyVectorOperator(operators.OfType<IIntegerVectorStdDevStrategyParameterOperator>());
+    }
+
+    //private void ConfigureCreators(IEnumerable<IPlushCreator> creators) {
+    //  foreach (var creator in creators) {
+    //    creator.IntegerVectorParameter.ActualName = Name;
+    //    creator.BoundsParameter.ActualName = BoundsParameter.Name;
+    //    creator.LengthParameter.ActualName = LengthParameter.Name;
+    //  }
+    //}
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEntry.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEntry.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEntry.cs	(revision 15273)
@@ -0,0 +1,8 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Encoding {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+
+  public class PlushEntry {
+    public Expression Instruction { get; set; }
+    public int Close { get; set; }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushVector.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushVector.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushVector.cs	(revision 15273)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Encoding {
+  using System.Collections.Generic;
+
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class PlushVector : Item {
+
+    private List<PlushEntry> entries;
+
+    public PlushVector() : this(0) {
+
+    }
+
+    public PlushVector(int length) {
+      entries = new List<PlushEntry>(length);
+    }
+
+    [StorableConstructor]
+    public PlushVector(bool deserializing) : base(deserializing) {
+    }
+
+    public PlushVector(PlushVector origin, Cloner cloner) : base(origin, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PlushVector(this, cloner);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15273)
@@ -20,4 +20,5 @@
     private static readonly Dictionary<StackTypes, IList<string>> stackDependencyToNamesTable = new Dictionary<StackTypes, IList<string>>();
     private static readonly Dictionary<Type, PushExpressionAttribute> typeToAttributeTable = new Dictionary<Type, PushExpressionAttribute>();
+    private static readonly List<Expression> inExpressionTable = new List<Expression>();
 
     public static readonly IReadOnlyList<Type> StatelessExpressionTypes;
@@ -43,4 +44,5 @@
     public static IReadOnlyDictionary<Type, string> TypeToNameTable { get { return typeToNameTable; } }
     public static IReadOnlyDictionary<string, Type> NameToTypeTable { get { return nameToTypeTable; } }
+    public static IReadOnlyList<Expression> InExpressionTable { get { return inExpressionTable; } }
     public static IReadOnlyDictionary<StackTypes, IList<string>> StackTypeToNamesTable { get { return stackTypeToNamesTable; } }
     public static IReadOnlyDictionary<StackTypes, IList<string>> StackDependencyToNamesTable { get { return stackDependencyToNamesTable; } }
@@ -57,10 +59,13 @@
         dictionary.Add(type, expression);
 
-        //// do not index hidden expressions like push expression in tables
-        //if (attribute.IsHidden) continue;
-
         indexToNameTable.Add(indexToNameTable.Keys.Count, attribute.Name);
         typeToNameTable.Add(type, attribute.Name);
         nameToTypeTable.Add(attribute.Name, type);
+
+        if (attribute.IsInExpression) {
+          // ReSharper disable once AssignNullToNotNullAttribute
+          // ReSharper disable once PossibleInvalidOperationException
+          inExpressionTable.Insert(attribute.InExpressionNr.Value - 1, expression);
+        }
 
         if (!stackTypeToNamesTable.ContainsKey(attribute.StackType)) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/InExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/InExpressions.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/InExpressions.cs	(revision 15273)
@@ -13,5 +13,5 @@
 
     protected InExpression(int nr) {
-      this.index = nr - 1;
+      index = nr - 1;
     }
 
@@ -20,11 +20,13 @@
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
-      return false;
+      var expression = interpreter.InputExpressions[index];
+
+      return expression.IsNoop(interpreter);
     }
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      var inputArgument = interpreter.InputExpressions[index];
+      var expression = interpreter.InputExpressions[index];
 
-      inputArgument.Eval(interpreter);
+      expression.Eval(interpreter);
     }
   }
@@ -34,5 +36,6 @@
     "IN1",
     "Pushes first input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 1)]
   [StorableClass]
   public class In1Expression : InExpression {
@@ -47,5 +50,6 @@
     "IN2",
     "Pushes second input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 2)]
   [StorableClass]
   public class In2Expression : InExpression {
@@ -60,5 +64,6 @@
    "IN3",
    "Pushes third input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 3)]
   [StorableClass]
   public class In3Expression : InExpression {
@@ -73,5 +78,6 @@
     "IN4",
     "Pushes fourth input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 4)]
   [StorableClass]
   public class In4Expression : InExpression {
@@ -86,5 +92,6 @@
     "IN5",
     "Pushes fifth input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 5)]
   [StorableClass]
   public class In5Expression : InExpression {
@@ -99,5 +106,6 @@
     "IN6",
     "Pushes sixth input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 6)]
   [StorableClass]
   public class In6Expression : InExpression {
@@ -112,5 +120,6 @@
     "IN7",
     "Pushes seventh input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 7)]
   [StorableClass]
   public class In7Expression : InExpression {
@@ -125,5 +134,6 @@
     "IN8",
     "Pushes eighth input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 8)]
   [StorableClass]
   public class In8Expression : InExpression {
@@ -138,5 +148,6 @@
     "IN9",
     "Pushes nineth input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 9)]
   [StorableClass]
   public class In9Expression : InExpression {
@@ -151,5 +162,6 @@
     "IN10",
     "Pushes tenth input parameter.",
-    isHidden: true)]
+    isHidden: true,
+    inExpressionNr: 10)]
   [StorableClass]
   public class In10Expression : InExpression {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 15273)
@@ -7,58 +7,78 @@
 
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Extensions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator;
 
   using Stack;
 
   internal static class CodeGeneratorUtils {
-    internal static Expression CreateExpressionOrErc(
+    private static readonly Expression Noop = ExpressionTable.GetStatelessExpression<ExecNoopExpression>();
+
+    internal static Expression MapToExpression(
       IRandom random,
-      IReadOnlyList<string> enabledExpressions,
       IReadOnlyErcOptions ercOptions,
+      IReadOnlyExpressionsConfiguration config,
       IDictionary<string, Expression> customExpressions = null) {
       var customCount = customExpressions == null ? 0 : customExpressions.Count;
-      var index = random.Next(enabledExpressions.Count + customCount);
+      var enabledExpressionCount = config.EnabledExpressions.Count;
+      var index = random.Next(enabledExpressionCount + customCount);
 
-      return index >= enabledExpressions.Count
-        ? customExpressions.Values.ElementAt(index - enabledExpressions.Count)
-        : CreateExpressionOrErc(index, random, enabledExpressions, ercOptions);
+      return index >= config.EnabledExpressions.Count
+        ? customExpressions.Values.ElementAt(index - enabledExpressionCount)
+        : MapToExpression(index, random, ercOptions, config);
     }
 
-    internal static Expression CreateExpressionOrErc(
+    internal static Expression MapToExpression(
       int index,
       IRandom random,
-      IReadOnlyList<string> enabledExpressions,
-      IReadOnlyErcOptions ercOptions) {
-      var name = enabledExpressions[index];
+      IReadOnlyErcOptions ercOptions,
+      IReadOnlyExpressionsConfiguration config) {
 
-      return CreateExpressionOrErc(name, random, ercOptions);
+      switch (index) {
+        case PushSolutionEncoding.Noop:
+          return Noop;
+
+        case PushSolutionEncoding.Erc:
+          var stackType = config.ExpressionsPerStackCount.RandomWeightedOrDefault(random, pair => pair.Value).Key;
+
+          if (stackType == default(StackTypes))
+            break;
+
+          return CreateRandomErcExpression(stackType, random, ercOptions);
+
+        case PushSolutionEncoding.In:
+          if (config.InExpressionCount == 0) break;
+
+          var nr = random.Next(0, config.InExpressionCount) + 1;
+          return ExpressionTable.InExpressionTable[nr];
+      }
+
+      var name = config.EnabledExpressions[index];
+      return ExpressionTable.GetExpression(name);
     }
 
-    private static Expression CreateExpressionOrErc(
-      string expressionName,
-      IRandom random,
-      IReadOnlyErcOptions ercOptions) {
-      //var x = random.NextDouble();
-      //Expression expression = null;
+    //private static Expression CreateExpressionOrErc(
+    //  string expressionName,
+    //  IRandom random,
+    //  IReadOnlyErcOptions ercOptions) {
+    //  var x = random.NextDouble();
+    //  Expression expression = null;
 
-      //if (x < ercOptions.ErcProbability) {
-      //  var expressionType = ExpressionTable.NameToTypeTable[expressionName];
-      //  expression = CreateRandomErcExpression(
-      //      ExpressionTable.TypeToAttributeTable[expressionType].StackType,
-      //      random,
-      //      ercOptions);
-      //}
+    //  if (x < ercOptions.ErcProbability) {
+    //    var expressionType = ExpressionTable.NameToTypeTable[expressionName];
+    //    expression = CreateRandomErcExpression(
+    //        ExpressionTable.TypeToAttributeTable[expressionType].StackType,
+    //        random,
+    //        ercOptions);
+    //  }
 
-      //if (expression == null || expression is ExecNoopExpression) {
-      //  expression = ExpressionTable.GetExpression(expressionName);
-      //}
+    //  if (expression == null || expression is ExecNoopExpression) {
+    //    expression = ExpressionTable.GetExpression(expressionName);
+    //  }
 
-      //return expression;
+    //  return expression;
+    //}
 
-      var expression = ExpressionTable.GetExpression(expressionName);
-
-      return expression;
-    }
-
-    private static readonly Expression Noop = ExpressionTable.GetStatelessExpression<ExecNoopExpression>();
     /// <summary>
     /// Create a ErcExpression whereby the type of the expression conforms to the passed stack type.
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/LinearCodeGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/LinearCodeGenerator.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/LinearCodeGenerator.cs	(revision 15273)
@@ -31,11 +31,11 @@
       IManagedPool<PooledList<Expression>> expressionListPool = null,
       IRandom random = null,
-      IReadOnlyPushConfiguration pushConfiguration = null,
+      IReadOnlyPushConfiguration config = null,
       IDictionary<string, Expression> customExpressions = null) {
       if (maxPoints == 0)
         return new Expression[0];
 
-      random = random ?? new FastRandom();
-      pushConfiguration = pushConfiguration ?? new PushConfiguration();
+      random = random ?? new MersenneTwister();
+      config = config ?? new PushConfiguration();
 
       var size = maxPoints <= 1 ? 1 : random.Next(1, maxPoints);
@@ -43,8 +43,8 @@
 
       for (var i = 0; i < size; i++) {
-        var expression = CodeGeneratorUtils.CreateExpressionOrErc(
+        var expression = CodeGeneratorUtils.MapToExpression(
           random,
-          pushConfiguration.EnabledExpressions,
-          pushConfiguration.ErcOptions,
+          config.ErcOptions,
+          config,
           customExpressions);
 
